/* ease-dialogs.c generated by valac, the Vala compiler
 * generated from ease-dialogs.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef void (*EaseDialogFileChooserDialogExtension) (GtkFileChooserDialog* d, void* user_data);


char* ease_dialog_open_ext (const char* title, GtkWindow* modal, EaseDialogFileChooserDialogExtension ext, void* ext_target);
char* ease_dialog_open (const char* title, GtkWindow* modal);
static void _lambda65_ (GtkFileChooserDialog* dialog);
static void __lambda65__ease_dialog_file_chooser_dialog_extension (GtkFileChooserDialog* d, gpointer self);
char* ease_dialog_open_document (GtkWindow* modal);
char* ease_dialog_save_ext (const char* title, GtkWindow* modal, EaseDialogFileChooserDialogExtension ext, void* ext_target);
char* ease_dialog_save (const char* title, GtkWindow* modal);
static void _lambda66_ (GtkFileChooserDialog* dialog);
static void __lambda66__ease_dialog_file_chooser_dialog_extension (GtkFileChooserDialog* d, gpointer self);
char* ease_dialog_save_document (const char* title, GtkWindow* modal);



#line 30 "ease-dialogs.vala"
char* ease_dialog_open (const char* title, GtkWindow* modal) {
#line 50 "ease-dialogs.c"
	char* result = NULL;
#line 30 "ease-dialogs.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 54 "ease-dialogs.c"
	result = ease_dialog_open_ext (title, modal, NULL, NULL);
#line 32 "ease-dialogs.vala"
	return result;
#line 58 "ease-dialogs.c"
}


#line 45 "ease-dialogs.vala"
char* ease_dialog_open_ext (const char* title, GtkWindow* modal, EaseDialogFileChooserDialogExtension ext, void* ext_target) {
#line 64 "ease-dialogs.c"
	char* result = NULL;
	GtkFileChooserDialog* dialog;
#line 45 "ease-dialogs.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 48 "ease-dialogs.vala"
	dialog = g_object_ref_sink ((GtkFileChooserDialog*) gtk_file_chooser_dialog_new (title, modal, GTK_FILE_CHOOSER_ACTION_OPEN, "gtk-cancel", GTK_RESPONSE_CANCEL, "gtk-open", GTK_RESPONSE_ACCEPT, NULL));
#line 55 "ease-dialogs.vala"
	if (ext != NULL) {
#line 55 "ease-dialogs.vala"
		ext (dialog, ext_target);
#line 75 "ease-dialogs.c"
	}
#line 57 "ease-dialogs.vala"
	if (gtk_dialog_run ((GtkDialog*) dialog) == GTK_RESPONSE_ACCEPT) {
#line 79 "ease-dialogs.c"
		char* name;
#line 59 "ease-dialogs.vala"
		name = gtk_file_chooser_get_filename ((GtkFileChooser*) dialog);
#line 60 "ease-dialogs.vala"
		gtk_object_destroy ((GtkObject*) dialog);
#line 85 "ease-dialogs.c"
		result = name;
		_g_object_unref0 (dialog);
#line 61 "ease-dialogs.vala"
		return result;
#line 90 "ease-dialogs.c"
	}
#line 63 "ease-dialogs.vala"
	gtk_object_destroy ((GtkObject*) dialog);
#line 94 "ease-dialogs.c"
	result = NULL;
	_g_object_unref0 (dialog);
#line 64 "ease-dialogs.vala"
	return result;
#line 99 "ease-dialogs.c"
}


#line 75 "ease-dialogs.vala"
static void _lambda65_ (GtkFileChooserDialog* dialog) {
#line 105 "ease-dialogs.c"
	GtkFileFilter* filter;
	GtkFileFilter* _tmp0_;
#line 75 "ease-dialogs.vala"
	g_return_if_fail (dialog != NULL);
#line 77 "ease-dialogs.vala"
	filter = g_object_ref_sink (gtk_file_filter_new ());
#line 78 "ease-dialogs.vala"
	gtk_file_filter_add_pattern (filter, "*.ease");
#line 79 "ease-dialogs.vala"
	gtk_file_filter_set_name (filter, _ ("Ease Presentations"));
#line 80 "ease-dialogs.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) dialog, filter);
#line 83 "ease-dialogs.vala"
	filter = (_tmp0_ = g_object_ref_sink (gtk_file_filter_new ()), _g_object_unref0 (filter), _tmp0_);
#line 84 "ease-dialogs.vala"
	gtk_file_filter_set_name (filter, _ ("All Files"));
#line 85 "ease-dialogs.vala"
	gtk_file_filter_add_pattern (filter, "*");
#line 86 "ease-dialogs.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) dialog, filter);
#line 126 "ease-dialogs.c"
	_g_object_unref0 (filter);
}


#line 75 "ease-dialogs.vala"
static void __lambda65__ease_dialog_file_chooser_dialog_extension (GtkFileChooserDialog* d, gpointer self) {
#line 133 "ease-dialogs.c"
	_lambda65_ (d);
}


#line 73 "ease-dialogs.vala"
char* ease_dialog_open_document (GtkWindow* modal) {
#line 140 "ease-dialogs.c"
	char* result = NULL;
	result = ease_dialog_open_ext (_ ("Open Document"), modal, __lambda65__ease_dialog_file_chooser_dialog_extension, NULL);
#line 75 "ease-dialogs.vala"
	return result;
#line 145 "ease-dialogs.c"
}


#line 97 "ease-dialogs.vala"
char* ease_dialog_save (const char* title, GtkWindow* modal) {
#line 151 "ease-dialogs.c"
	char* result = NULL;
#line 97 "ease-dialogs.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 155 "ease-dialogs.c"
	result = ease_dialog_save_ext (title, modal, NULL, NULL);
#line 99 "ease-dialogs.vala"
	return result;
#line 159 "ease-dialogs.c"
}


#line 112 "ease-dialogs.vala"
char* ease_dialog_save_ext (const char* title, GtkWindow* modal, EaseDialogFileChooserDialogExtension ext, void* ext_target) {
#line 165 "ease-dialogs.c"
	char* result = NULL;
	GtkFileChooserDialog* dialog;
#line 112 "ease-dialogs.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 115 "ease-dialogs.vala"
	dialog = g_object_ref_sink ((GtkFileChooserDialog*) gtk_file_chooser_dialog_new (title, modal, GTK_FILE_CHOOSER_ACTION_SAVE, "gtk-save", GTK_RESPONSE_ACCEPT, "gtk-cancel", GTK_RESPONSE_CANCEL, NULL, NULL));
#line 123 "ease-dialogs.vala"
	if (ext != NULL) {
#line 123 "ease-dialogs.vala"
		ext (dialog, ext_target);
#line 176 "ease-dialogs.c"
	}
#line 125 "ease-dialogs.vala"
	if (gtk_dialog_run ((GtkDialog*) dialog) == GTK_RESPONSE_ACCEPT) {
#line 180 "ease-dialogs.c"
		char* path;
#line 128 "ease-dialogs.vala"
		path = gtk_file_chooser_get_filename ((GtkFileChooser*) dialog);
#line 129 "ease-dialogs.vala"
		gtk_object_destroy ((GtkObject*) dialog);
#line 186 "ease-dialogs.c"
		result = path;
		_g_object_unref0 (dialog);
#line 130 "ease-dialogs.vala"
		return result;
#line 191 "ease-dialogs.c"
	}
#line 132 "ease-dialogs.vala"
	gtk_object_destroy ((GtkObject*) dialog);
#line 195 "ease-dialogs.c"
	result = NULL;
	_g_object_unref0 (dialog);
#line 133 "ease-dialogs.vala"
	return result;
#line 200 "ease-dialogs.c"
}


#line 146 "ease-dialogs.vala"
static void _lambda66_ (GtkFileChooserDialog* dialog) {
#line 206 "ease-dialogs.c"
	GtkFileFilter* filter;
	GtkFileFilter* _tmp0_;
#line 146 "ease-dialogs.vala"
	g_return_if_fail (dialog != NULL);
#line 148 "ease-dialogs.vala"
	filter = g_object_ref_sink (gtk_file_filter_new ());
#line 149 "ease-dialogs.vala"
	gtk_file_filter_add_pattern (filter, "*.ease");
#line 150 "ease-dialogs.vala"
	gtk_file_filter_set_name (filter, _ ("Ease Presentations"));
#line 151 "ease-dialogs.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) dialog, filter);
#line 154 "ease-dialogs.vala"
	filter = (_tmp0_ = g_object_ref_sink (gtk_file_filter_new ()), _g_object_unref0 (filter), _tmp0_);
#line 155 "ease-dialogs.vala"
	gtk_file_filter_set_name (filter, _ ("All Files"));
#line 156 "ease-dialogs.vala"
	gtk_file_filter_add_pattern (filter, "*");
#line 157 "ease-dialogs.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) dialog, filter);
#line 227 "ease-dialogs.c"
	_g_object_unref0 (filter);
}


#line 146 "ease-dialogs.vala"
static void __lambda66__ease_dialog_file_chooser_dialog_extension (GtkFileChooserDialog* d, gpointer self) {
#line 234 "ease-dialogs.c"
	_lambda66_ (d);
}


#line 144 "ease-dialogs.vala"
char* ease_dialog_save_document (const char* title, GtkWindow* modal) {
#line 241 "ease-dialogs.c"
	char* result = NULL;
#line 144 "ease-dialogs.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 245 "ease-dialogs.c"
	result = ease_dialog_save_ext (title, modal, __lambda66__ease_dialog_file_chooser_dialog_extension, NULL);
#line 146 "ease-dialogs.vala"
	return result;
#line 249 "ease-dialogs.c"
}




