/* ease-temp.c generated by valac, the Vala compiler
 * generated from ease-temp.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <archive.h>
#include <archive_entry.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>


#define EASE_TYPE_TEMP (ease_temp_get_type ())
#define EASE_TEMP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_TEMP, EaseTemp))
#define EASE_TEMP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_TEMP, EaseTempClass))
#define EASE_IS_TEMP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_TEMP))
#define EASE_IS_TEMP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_TEMP))
#define EASE_TEMP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_TEMP, EaseTempClass))

typedef struct _EaseTemp EaseTemp;
typedef struct _EaseTempClass EaseTempClass;
typedef struct _EaseTempPrivate EaseTempPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _archive_read_finish0(var) ((var == NULL) ? NULL : (var = (archive_read_finish (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _EaseTemp {
	GObject parent_instance;
	EaseTempPrivate * priv;
};

struct _EaseTempClass {
	GObjectClass parent_class;
};


static gint ease_temp_index;
static gint ease_temp_index = 0;
static char* ease_temp_m_temp;
static char* ease_temp_m_temp = NULL;
static GeeLinkedList* ease_temp_m_dirs;
static GeeLinkedList* ease_temp_m_dirs = NULL;
static gpointer ease_temp_parent_class = NULL;

GType ease_temp_get_type (void) G_GNUC_CONST;
enum  {
	EASE_TEMP_DUMMY_PROPERTY
};
#define EASE_TEMP_ARCHIVE_BUFFER 4096
#define EASE_TEMP_TEMP_DIR "ease"
#define EASE_TEMP_THEME_DIR "themes"
#define EASE_TEMP_IMG_DIR "svg"
#define EASE_TEMP_UI_DIR "ui"
gboolean ease_temp_exists (gint dir, const char* tmp);
static const char* ease_temp_get_temp (void);
static GeeLinkedList* ease_temp_get_dirs (void);
char* ease_temp_request (GError** error);
char* ease_temp_request_str (const char* str, GError** error);
char* ease_temp_extract (const char* filename, GError** error);
void ease_recursive_delete (const char* path, GError** error);
void ease_temp_clean (void);
EaseTemp* ease_temp_new (void);
EaseTemp* ease_temp_construct (GType object_type);
static void ease_temp_finalize (GObject* obj);
static void ease_temp_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);



#line 70 "ease-temp.vala"
char* ease_temp_request (GError** error) {
#line 95 "ease-temp.c"
	char* result = NULL;
	GError * _inner_error_;
	char* _tmp0_;
	char* _tmp1_;
	char* tmp;
	GFile* file;
	_inner_error_ = NULL;
#line 73 "ease-temp.vala"
	while (TRUE) {
#line 73 "ease-temp.vala"
		if (!ease_temp_exists (ease_temp_index, ease_temp_get_temp ())) {
#line 73 "ease-temp.vala"
			break;
#line 109 "ease-temp.c"
		}
#line 75 "ease-temp.vala"
		ease_temp_index++;
#line 113 "ease-temp.c"
	}
#line 79 "ease-temp.vala"
	tmp = (_tmp1_ = g_build_filename (ease_temp_get_temp (), _tmp0_ = g_strdup_printf ("%i", ease_temp_index), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 82 "ease-temp.vala"
	gee_deque_offer_head ((GeeDeque*) ease_temp_get_dirs (), tmp);
#line 85 "ease-temp.vala"
	file = g_file_new_for_path (tmp);
#line 86 "ease-temp.vala"
	g_file_make_directory_with_parents (file, NULL, &_inner_error_);
#line 123 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		_g_free0 (tmp);
		return NULL;
	}
	result = tmp;
	_g_object_unref0 (file);
#line 88 "ease-temp.vala"
	return result;
#line 134 "ease-temp.c"
}


#line 103 "ease-temp.vala"
char* ease_temp_request_str (const char* str, GError** error) {
#line 140 "ease-temp.c"
	char* result = NULL;
	GError * _inner_error_;
	char* tmp;
	GFile* file;
#line 103 "ease-temp.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 147 "ease-temp.c"
	_inner_error_ = NULL;
#line 106 "ease-temp.vala"
	tmp = g_build_filename (ease_temp_get_temp (), str, NULL);
#line 107 "ease-temp.vala"
	file = g_file_new_for_path (tmp);
#line 108 "ease-temp.vala"
	if (g_file_query_exists (file, NULL)) {
#line 155 "ease-temp.c"
		{
			gint i;
#line 110 "ease-temp.vala"
			i = 0;
#line 160 "ease-temp.c"
			{
				gboolean _tmp0_;
#line 110 "ease-temp.vala"
				_tmp0_ = TRUE;
#line 110 "ease-temp.vala"
				while (TRUE) {
#line 167 "ease-temp.c"
					char* _tmp4_;
					char* _tmp3_;
					char* _tmp2_;
					char* _tmp1_;
					GFile* _tmp5_;
#line 110 "ease-temp.vala"
					if (!_tmp0_) {
#line 110 "ease-temp.vala"
						i++;
#line 177 "ease-temp.c"
					}
#line 110 "ease-temp.vala"
					_tmp0_ = FALSE;
#line 110 "ease-temp.vala"
					if (!g_file_query_exists (file, NULL)) {
#line 110 "ease-temp.vala"
						break;
#line 185 "ease-temp.c"
					}
#line 112 "ease-temp.vala"
					tmp = (_tmp4_ = g_build_filename (ease_temp_get_temp (), _tmp3_ = g_strconcat (_tmp1_ = g_strconcat (str, "-", NULL), _tmp2_ = g_strdup_printf ("%i", i), NULL), NULL), _g_free0 (tmp), _tmp4_);
#line 189 "ease-temp.c"
					_g_free0 (_tmp3_);
					_g_free0 (_tmp2_);
					_g_free0 (_tmp1_);
#line 113 "ease-temp.vala"
					file = (_tmp5_ = g_file_new_for_path (tmp), _g_object_unref0 (file), _tmp5_);
#line 195 "ease-temp.c"
				}
			}
		}
	}
#line 118 "ease-temp.vala"
	gee_deque_offer_head ((GeeDeque*) ease_temp_get_dirs (), tmp);
#line 121 "ease-temp.vala"
	g_file_make_directory_with_parents (file, NULL, &_inner_error_);
#line 204 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		_g_free0 (tmp);
		return NULL;
	}
	result = tmp;
	_g_object_unref0 (file);
#line 123 "ease-temp.vala"
	return result;
#line 215 "ease-temp.c"
}


#line 135 "ease-temp.vala"
char* ease_temp_extract (const char* filename, GError** error) {
#line 221 "ease-temp.c"
	char* result = NULL;
	GError * _inner_error_;
	struct archive* archive;
	char* path;
	struct archive_entry* entry;
#line 135 "ease-temp.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 229 "ease-temp.c"
	_inner_error_ = NULL;
#line 138 "ease-temp.vala"
	archive = archive_read_new ();
#line 141 "ease-temp.vala"
	archive_read_support_compression_all (archive);
#line 142 "ease-temp.vala"
	archive_read_support_format_all (archive);
#line 145 "ease-temp.vala"
	archive_read_open_filename (archive, filename, (gsize) EASE_TEMP_ARCHIVE_BUFFER);
#line 148 "ease-temp.vala"
	path = ease_temp_request (&_inner_error_);
#line 241 "ease-temp.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_archive_read_finish0 (archive);
		return NULL;
	}
	entry = NULL;
#line 152 "ease-temp.vala"
	while (TRUE) {
#line 250 "ease-temp.c"
		char* fpath;
		GFile* file;
#line 152 "ease-temp.vala"
		if (!(archive_read_next_header (archive, &entry) == ARCHIVE_OK)) {
#line 152 "ease-temp.vala"
			break;
#line 257 "ease-temp.c"
		}
#line 154 "ease-temp.vala"
		fpath = g_build_filename (path, archive_entry_pathname (entry), NULL);
#line 155 "ease-temp.vala"
		file = g_file_new_for_path (fpath);
#line 157 "ease-temp.vala"
		if (S_ISDIR (archive_entry_mode (entry))) {
#line 159 "ease-temp.vala"
			g_file_make_directory_with_parents (file, NULL, &_inner_error_);
#line 267 "ease-temp.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (file);
				_g_free0 (fpath);
				_g_free0 (path);
				_archive_read_finish0 (archive);
				return NULL;
			}
		} else {
			GFile* parent;
			GFileOutputStream* _tmp0_;
			gint fd;
#line 163 "ease-temp.vala"
			parent = g_file_get_parent (file);
#line 164 "ease-temp.vala"
			if (!g_file_query_exists (parent, NULL)) {
#line 166 "ease-temp.vala"
				g_file_make_directory_with_parents (parent, NULL, &_inner_error_);
#line 286 "ease-temp.c"
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (parent);
					_g_object_unref0 (file);
					_g_free0 (fpath);
					_g_free0 (path);
					_archive_read_finish0 (archive);
					return NULL;
				}
			}
#line 169 "ease-temp.vala"
			_tmp0_ = g_file_create (file, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 299 "ease-temp.c"
			_g_object_unref0 (_tmp0_);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (parent);
				_g_object_unref0 (file);
				_g_free0 (fpath);
				_g_free0 (path);
				_archive_read_finish0 (archive);
				return NULL;
			}
#line 170 "ease-temp.vala"
			fd = open (fpath, O_WRONLY, (mode_t) 0644);
#line 171 "ease-temp.vala"
			archive_read_data_into_fd (archive, fd);
#line 172 "ease-temp.vala"
			close (fd);
#line 316 "ease-temp.c"
			_g_object_unref0 (parent);
		}
		_g_object_unref0 (file);
		_g_free0 (fpath);
	}
	result = path;
	_archive_read_finish0 (archive);
#line 176 "ease-temp.vala"
	return result;
#line 326 "ease-temp.c"
}


#line 183 "ease-temp.vala"
void ease_temp_clean (void) {
#line 332 "ease-temp.c"
	GError * _inner_error_;
	char* dir;
	char* tmp;
	_inner_error_ = NULL;
#line 185 "ease-temp.vala"
	if (ease_temp_get_dirs () == NULL) {
#line 185 "ease-temp.vala"
		return;
#line 341 "ease-temp.c"
	}
	dir = NULL;
#line 188 "ease-temp.vala"
	while (TRUE) {
#line 346 "ease-temp.c"
		char* _tmp0_;
#line 188 "ease-temp.vala"
		if (!((dir = (_tmp0_ = (char*) gee_deque_poll_head ((GeeDeque*) ease_temp_get_dirs ()), _g_free0 (dir), _tmp0_)) != NULL)) {
#line 188 "ease-temp.vala"
			break;
#line 352 "ease-temp.c"
		}
		{
#line 190 "ease-temp.vala"
			ease_recursive_delete (dir, &_inner_error_);
#line 357 "ease-temp.c"
			if (_inner_error_ != NULL) {
				goto __catch19_g_error;
			}
		}
		goto __finally19;
		__catch19_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 193 "ease-temp.vala"
				g_debug ("ease-temp.vala:193: %s", e->message);
#line 371 "ease-temp.c"
				_g_error_free0 (e);
			}
		}
		__finally19:
		if (_inner_error_ != NULL) {
			_g_free0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 201 "ease-temp.vala"
	tmp = g_build_filename (g_get_tmp_dir (), EASE_TEMP_TEMP_DIR, NULL);
#line 385 "ease-temp.c"
	{
		GFile* file;
		GFile* _tmp1_;
#line 205 "ease-temp.vala"
		file = g_file_new_for_path (ease_temp_get_temp ());
#line 206 "ease-temp.vala"
		g_file_delete (file, NULL, &_inner_error_);
#line 393 "ease-temp.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			goto __catch20_g_error;
		}
#line 209 "ease-temp.vala"
		file = (_tmp1_ = g_file_new_for_path (tmp), _g_object_unref0 (file), _tmp1_);
#line 210 "ease-temp.vala"
		g_file_delete (file, NULL, &_inner_error_);
#line 402 "ease-temp.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			goto __catch20_g_error;
		}
		_g_object_unref0 (file);
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	__finally20:
	if (_inner_error_ != NULL) {
		_g_free0 (tmp);
		_g_free0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (tmp);
	_g_free0 (dir);
}


#line 221 "ease-temp.vala"
gboolean ease_temp_exists (gint dir, const char* tmp) {
#line 434 "ease-temp.c"
	gboolean result = FALSE;
	char* _tmp0_;
	char* _tmp1_;
	char* dir_tmp;
	GFile* file;
#line 221 "ease-temp.vala"
	g_return_val_if_fail (tmp != NULL, FALSE);
#line 223 "ease-temp.vala"
	dir_tmp = (_tmp1_ = g_build_filename (tmp, _tmp0_ = g_strdup_printf ("%i", dir), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 224 "ease-temp.vala"
	file = g_file_new_for_path (dir_tmp);
#line 446 "ease-temp.c"
	result = g_file_query_exists (file, NULL);
	_g_object_unref0 (file);
	_g_free0 (dir_tmp);
#line 226 "ease-temp.vala"
	return result;
#line 452 "ease-temp.c"
}


#line 31 "ease-temp.vala"
EaseTemp* ease_temp_construct (GType object_type) {
#line 458 "ease-temp.c"
	EaseTemp * self;
#line 31 "ease-temp.vala"
	self = (EaseTemp*) g_object_new (object_type, NULL);
#line 462 "ease-temp.c"
	return self;
}


#line 31 "ease-temp.vala"
EaseTemp* ease_temp_new (void) {
#line 31 "ease-temp.vala"
	return ease_temp_construct (EASE_TYPE_TEMP);
#line 471 "ease-temp.c"
}


static const char* ease_temp_get_temp (void) {
	const char* result;
	char* _tmp1_;
	char* _tmp0_;
#line 40 "ease-temp.vala"
	if (ease_temp_m_temp != NULL) {
#line 481 "ease-temp.c"
		result = ease_temp_m_temp;
#line 40 "ease-temp.vala"
		return result;
#line 485 "ease-temp.c"
	}
#line 41 "ease-temp.vala"
	ease_temp_m_temp = (_tmp1_ = g_build_filename (g_get_tmp_dir (), EASE_TEMP_TEMP_DIR, _tmp0_ = g_strdup_printf ("%i", (gint) getpid ()), NULL), _g_free0 (ease_temp_m_temp), _tmp1_);
#line 489 "ease-temp.c"
	_g_free0 (_tmp0_);
	result = ease_temp_m_temp;
#line 43 "ease-temp.vala"
	return result;
#line 494 "ease-temp.c"
}


static GeeLinkedList* ease_temp_get_dirs (void) {
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 52 "ease-temp.vala"
	if (ease_temp_m_dirs != NULL) {
#line 503 "ease-temp.c"
		result = ease_temp_m_dirs;
#line 52 "ease-temp.vala"
		return result;
#line 507 "ease-temp.c"
	}
	result = ease_temp_m_dirs = (_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL), _g_object_unref0 (ease_temp_m_dirs), _tmp0_);
#line 53 "ease-temp.vala"
	return result;
#line 512 "ease-temp.c"
}


static void ease_temp_class_init (EaseTempClass * klass) {
	ease_temp_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = ease_temp_get_property;
	G_OBJECT_CLASS (klass)->finalize = ease_temp_finalize;
}


static void ease_temp_instance_init (EaseTemp * self) {
}


static void ease_temp_finalize (GObject* obj) {
	EaseTemp * self;
	self = EASE_TEMP (obj);
	G_OBJECT_CLASS (ease_temp_parent_class)->finalize (obj);
}


GType ease_temp_get_type (void) {
	static volatile gsize ease_temp_type_id__volatile = 0;
	if (g_once_init_enter (&ease_temp_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseTempClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_temp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseTemp), 0, (GInstanceInitFunc) ease_temp_instance_init, NULL };
		GType ease_temp_type_id;
		ease_temp_type_id = g_type_register_static (G_TYPE_OBJECT, "EaseTemp", &g_define_type_info, 0);
		g_once_init_leave (&ease_temp_type_id__volatile, ease_temp_type_id);
	}
	return ease_temp_type_id__volatile;
}


static void ease_temp_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	EaseTemp * self;
	self = EASE_TEMP (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




